// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package grpcdatastream

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// DataStreamClient is the client API for DataStream service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type DataStreamClient interface {
	GetRandomDataStream(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (DataStream_GetRandomDataStreamClient, error)
}

type dataStreamClient struct {
	cc grpc.ClientConnInterface
}

func NewDataStreamClient(cc grpc.ClientConnInterface) DataStreamClient {
	return &dataStreamClient{cc}
}

func (c *dataStreamClient) GetRandomDataStream(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (DataStream_GetRandomDataStreamClient, error) {
	stream, err := c.cc.NewStream(ctx, &DataStream_ServiceDesc.Streams[0], "/DataStream/GetRandomDataStream", opts...)
	if err != nil {
		return nil, err
	}
	x := &dataStreamGetRandomDataStreamClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type DataStream_GetRandomDataStreamClient interface {
	Recv() (*GetRandomDataStreamRes, error)
	grpc.ClientStream
}

type dataStreamGetRandomDataStreamClient struct {
	grpc.ClientStream
}

func (x *dataStreamGetRandomDataStreamClient) Recv() (*GetRandomDataStreamRes, error) {
	m := new(GetRandomDataStreamRes)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// DataStreamServer is the server API for DataStream service.
// All implementations must embed UnimplementedDataStreamServer
// for forward compatibility
type DataStreamServer interface {
	GetRandomDataStream(*emptypb.Empty, DataStream_GetRandomDataStreamServer) error
	mustEmbedUnimplementedDataStreamServer()
}

// UnimplementedDataStreamServer must be embedded to have forward compatible implementations.
type UnimplementedDataStreamServer struct {
}

func (UnimplementedDataStreamServer) GetRandomDataStream(*emptypb.Empty, DataStream_GetRandomDataStreamServer) error {
	return status.Errorf(codes.Unimplemented, "method GetRandomDataStream not implemented")
}
func (UnimplementedDataStreamServer) mustEmbedUnimplementedDataStreamServer() {}

// UnsafeDataStreamServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to DataStreamServer will
// result in compilation errors.
type UnsafeDataStreamServer interface {
	mustEmbedUnimplementedDataStreamServer()
}

func RegisterDataStreamServer(s grpc.ServiceRegistrar, srv DataStreamServer) {
	s.RegisterService(&DataStream_ServiceDesc, srv)
}

func _DataStream_GetRandomDataStream_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(emptypb.Empty)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(DataStreamServer).GetRandomDataStream(m, &dataStreamGetRandomDataStreamServer{stream})
}

type DataStream_GetRandomDataStreamServer interface {
	Send(*GetRandomDataStreamRes) error
	grpc.ServerStream
}

type dataStreamGetRandomDataStreamServer struct {
	grpc.ServerStream
}

func (x *dataStreamGetRandomDataStreamServer) Send(m *GetRandomDataStreamRes) error {
	return x.ServerStream.SendMsg(m)
}

// DataStream_ServiceDesc is the grpc.ServiceDesc for DataStream service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var DataStream_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "DataStream",
	HandlerType: (*DataStreamServer)(nil),
	Methods:     []grpc.MethodDesc{},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "GetRandomDataStream",
			Handler:       _DataStream_GetRandomDataStream_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "cache.proto",
}
